<template>
	<div class="">
		<div class="container job-search-container">
			<div class="row justify-content-center">
				<h1 class="text-white font-weight-bold">
					<span style="color: #42b883">EDIT</span> JOB
				</h1 class="text-white">
			</div>
		</div>
		<div class="container mb-5">
			<div class="row justify-content-center">
				<div class="col-md-10 job-form-box pt-5">
					<el-form :model="jobForm" ref="jobForm" :rules="rules" :label-position="labelPosition" label-width="100px">
					  	<el-form-item label="Job Title" prop="title">
					    	<el-input v-model="jobForm.title" placeholder="Write job title">
					    		{{ jobForm.title }}
					    	</el-input>
					  	</el-form-item>
					  	<el-form-item label="Job Category" prop="category">
						    <el-select v-model="jobForm.category" placeholder="Select">
							    <el-option
							      v-for="item in categories"
							      :key="item.id"
							      :label="item.label"
							      :value="item.category">
							      {{ jobForm.category }}
							    </el-option>
							</el-select>
						</el-form-item>
						<el-form-item label="Salary" prop="salary">
						    <el-select v-model="jobForm.salary" placeholder="Select">
							    <el-option
							      v-for="item in salaries"
							      :key="item.id"
							      :label="item.label"
							      :value="item.salary">
							      {{ jobForm.salary }}
							    </el-option>
							</el-select>
						</el-form-item>
					  	<el-form-item label="Location (Optional)" prop="location">
					    	<el-input v-model="jobForm.location" placeholder="e.g.Yangon">
					    		{{ jobForm.location }}
					    	</el-input>
					  	</el-form-item>
					  	<el-form-item label="Position Type" prop="position_type">
						    <el-select v-model="jobForm.position_type" placeholder="Select">
							    <el-option
							      v-for="item in positions"
							      :key="item.id"
							      :label="item.label"
							      :value="item.position">
							      {{ jobForm.position_type }}
							    </el-option>
							</el-select>
						</el-form-item>
						<el-form-item label="Gender" prop="gender">
						  	<el-radio v-model="jobForm.gender" label="male">Male</el-radio>
						  	<el-radio v-model="jobForm.gender" label="female">Female</el-radio>
						  	<el-radio v-model="jobForm.gender" label="both">Both</el-radio>
						</el-form-item>
						<el-form-item label="Description" prop="desc">
							<!-- <vue-editor v-model="jobForm.desc"></vue-editor> -->
							<el-input
							  	type="textarea"
							  	:autosize="{ minRows: 3, maxRows: 5}"
							  	placeholder="Description"
							  	v-model="jobForm.desc">
							  	{{ jobForm.desc }}
							</el-input>
						</el-form-item>
						<div class="py-3">
							<hr class="mb-5">
							<h3><span style="color: #42b883">Company</span> Details</h3>
						</div>
					  	<el-form-item label="Company" prop="company_name" class="mt-3">
					    	<el-input v-model="jobForm.company_name" placeholder="Write company name">
					    		{{ jobForm.company_name }}
					    	</el-input>
					  	</el-form-item>
					  	<el-form-item label="Company Website">
					    	<el-input v-model="jobForm.company_website" placeholder="https://">
					    		{{ jobForm.company_website }}
					    	</el-input>
					  	</el-form-item>
						<el-form-item size="large" class="text-right">
						    <el-button type="success" @click="updateModal()" class="font-weight-bold">Update</el-button>
						</el-form-item>
					</el-form>
				</div>
			</div>
		</div>
	</div>
</template>

<style>
	.el-form {
		width: 60vw;
    	margin: auto;
	}
	.el-form-item {
		padding-bottom: 1rem;
	}
	.el-input__inner {
		border-radius: 30px;
		height: 40px;
	}
	.el-form--label-top .el-form-item__label {
		line-height: 0;
		margin-left: 5px;
		font-size: 18px;
	}
	.el-input.is-active .el-input__inner, .el-input__inner:focus {
		border-color: #42b883;
	}
	.el-textarea__inner:focus {
		border-color: #42b883;
	}
	.el-select {
		width: 100%;
	}
	.el-radio {
        color: #000;
    }
    .el-radio--medium.is-bordered .el-radio__label {
        font-size: 16px;
        font-weight: bold;
    }
    .el-radio.is-bordered.is-checked {
        border-color: #42b883; 
    }
    .el-radio__input.is-checked .el-radio__inner {
        border-color: #42b883;
        background: #42b883;
    }
    .el-radio__input.is-checked+.el-radio__label {
        color: #42b883;
    }
</style>

<script>
	export default {
		data() {
			return {
				id: this.$route.params.id,
				labelPosition: 'top',
				jobForm: {
		          	title: '',
		        	category: null,
		        	salary: '',
		          	location: '',
		          	desc: '',
		        	position_type: null,
		        	gender: '',
		          	company_name: '',
		          	company_website: '',
		        },
		        categories: [
			        {
			          category: 'Food & Service',
			          label: 'Food & Service'
			        }, {
			          category: 'IT & Engineering',
			          label: 'IT & Engineering'
			        }, {
			          category: 'Education/Training',
			          label: 'Education/Training'
			        }, {
			          category: 'Art/Design',
			          label: 'Art/Design'
			        }, {
			          category: 'Sale/Marketing',
			          label: 'Sale/Marketing'
			        }, {
			          category: 'Healthcare',
			          label: 'Healthcare'
			        }
		        ],
		        salaries: [
			        {
			          salary: '0 - 200K',
			          label: '0 - 200K'
			        }, {
			          salary: '200K - 400K',
			          label: '200K - 400K'
			        }, {
			          salary: '400K - 600K',
			          label: '400K - 600K'
			        }, {
			          salary: '600K - 800K',
			          label: '600K - 800K'
			        }, {
			          salary: 'More than 800K',
			          label: 'More than 800K'
			        }
		        ],
		        positions: [
			        {
			          position: 'Full Time',
			          label: 'Full Time'
			        }, {
			          position: 'Part Time',
			          label: 'Part Time'
			        }, {
			          position: 'Intership',
			          label: 'Intership'
			        }
		        ],
		        rules: {
		        	title: [
		            	{ required: true, message: 'Please input Job title', trigger: 'blur' }
		          	],
		          	category: [
		            	{ required: true, message: 'Please select one Category name', trigger: 'blur' }
		          	],
		          	salary: [
		            	{ required: true, message: 'Please select Salary', trigger: 'blur' }
		          	],
		          	location: [
		            	{ required: true, message: 'Please input location', trigger: 'blur' }
		          	],
		          	gender: [
		            	{ required: true, message: 'Please select gender type', trigger: 'blur' }
		          	],
		          	position_type: [
		          		{ required: true, message: 'Please select one Position type from above', trigger: 'blur' }
		          	],
		          	desc: [
		          		{ required: true, message: 'Please input Description', trigger: 'blur' }
		          	],
		        }
			}
		},
		mounted() {
			axios.get('/job/' + this.id +'/edit')
			.then(response => {
				this.jobForm.title = response.data.title;
				this.jobForm.category = response.data.category;
				this.jobForm.salary = response.data.salary;
				this.jobForm.location = response.data.location;
				this.jobForm.desc = response.data.description;
				this.jobForm.position_type = response.data.position_type;
				this.jobForm.gender = response.data.gender;
				this.jobForm.company_name = response.data.company_name;
				this.jobForm.company_website = response.data.company_website;
			});
		},
		methods: {
			updateCategory() {
				axios.patch('/job/' + this.id,{
					title: this.jobForm.title,
					category: this.jobForm.category,
					salary: this.jobForm.salary,
					location: this.jobForm.location,
					description: this.jobForm.desc,
					position_type: this.jobForm.position_type,
					gender: this.jobForm.gender,
					company_name: this.jobForm.company_name,
					company_website: this.jobForm.company_website,
				});
				this.$router.replace({ name: 'UserJoblist', params: { user_id: this.$auth.user().id} })
			},
			updateModal() {
				this.$confirm('Do you want to update?', 'Confirm', {
	         	distinguishCancelAndClose: true,
	         	confirmButtonText: 'Confirm',
	         	cancelButtonText: 'Discard Changes'
	       		})
	         	.then(() => {
		           	this.$message({
		             	type: 'success',
		             	message: 'Changes saved.',
		             	option: this.updateCategory()
		           	});
	         	})
	         	.catch(action => {
	           		this.$message({
	             	type: 'warning',
	             	message: action === 'cancel'
	               	? 'Changes discarded.'
	               	: 'Stay in the current route'
	           		});
	           		this.$router.replace({ name: 'UserJoblist', params: { user_id: this.$auth.user().id} })
				})
			}
		}
	}
</script>